/*
 * Copyright (C) 2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LIBEVENT_HANDLER_HH_55C01EB3480DA10346E7DEB6DC9662E1//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define LIBEVENT_HANDLER_HH_55C01EB3480DA10346E7DEB6DC9662E1

#include <amqpcpp.h>
#include <amqpcpp/libevent.h>

#include <functional>
#include <memory>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

std::unique_ptr<AMQP::TcpHandler> make_libevent_handler(
        struct ::event_base* service,
        std::function<void(AMQP::TcpConnection*)> on_ready = nullptr,
        std::function<void(AMQP::TcpConnection*, const char*)> on_error = nullptr,
        std::function<void(AMQP::TcpConnection*)> on_lost = nullptr);

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//LIBEVENT_HANDLER_HH_55C01EB3480DA10346E7DEB6DC9662E1
